<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_CruiseSupplement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_CruiseSupplement extends AbstractStructArrayBase
{
    /**
     * The CruiseSupplement
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_CruiseSupplement[]
     */
    public $CruiseSupplement;
    /**
     * Constructor method for ArrayOfJP_CruiseSupplement
     * @uses ArrayOfJP_CruiseSupplement::setCruiseSupplement()
     * @param \StructType\JP_CruiseSupplement[] $cruiseSupplement
     */
    public function __construct(array $cruiseSupplement = array())
    {
        $this
            ->setCruiseSupplement($cruiseSupplement);
    }
    /**
     * Get CruiseSupplement value
     * @return \StructType\JP_CruiseSupplement[]|null
     */
    public function getCruiseSupplement()
    {
        return $this->CruiseSupplement;
    }
    /**
     * Set CruiseSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplement[] $cruiseSupplement
     * @return \ArrayType\ArrayOfJP_CruiseSupplement
     */
    public function setCruiseSupplement(array $cruiseSupplement = array())
    {
        foreach ($cruiseSupplement as $arrayOfJP_CruiseSupplementCruiseSupplementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_CruiseSupplementCruiseSupplementItem instanceof \StructType\JP_CruiseSupplement) {
                throw new \InvalidArgumentException(sprintf('The CruiseSupplement property can only contain items of \StructType\JP_CruiseSupplement, "%s" given', is_object($arrayOfJP_CruiseSupplementCruiseSupplementItem) ? get_class($arrayOfJP_CruiseSupplementCruiseSupplementItem) : gettype($arrayOfJP_CruiseSupplementCruiseSupplementItem)), __LINE__);
            }
        }
        $this->CruiseSupplement = $cruiseSupplement;
        return $this;
    }
    /**
     * Add item to CruiseSupplement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_CruiseSupplement $item
     * @return \ArrayType\ArrayOfJP_CruiseSupplement
     */
    public function addToCruiseSupplement(\StructType\JP_CruiseSupplement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_CruiseSupplement) {
            throw new \InvalidArgumentException(sprintf('The CruiseSupplement property can only contain items of \StructType\JP_CruiseSupplement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CruiseSupplement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_CruiseSupplement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CruiseSupplement
     */
    public function getAttributeName()
    {
        return 'CruiseSupplement';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_CruiseSupplement
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
